<template>
  <div id="sidebarmenu">
    <sidebar-menu
      :menu="menu"
      :collapsed="collapsed"
      width="220px"
      :hideToggle="true"
      :theme="selectedTheme"
      :show-one-child="true"
    />
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { SidebarMenu } from 'vue-sidebar-menu';
import 'vue-sidebar-menu/dist/vue-sidebar-menu.css';

import { GuidUtil, LinkUtil } from '@coscine/app-util';

import { ProjectApi, ProjectRoleApi, SubProjectApi, ResourceApi , ActivatedFeaturesApi} from '@coscine/api-connection';

export default Vue.extend({
  name: 'sidebarmenu',
  components: {
    SidebarMenu,
  },
  data() {
    return {
      projectId: String,
      projectName: '',
      resourceId: '',
      projects: [] as object[],
      subprojects: [] as object[],
      resources: [] as object[],
      isOwner: false,
      baseUrl: '',
      selectedTheme: 'white-theme',
      collapsed: false,
      menu: [] as object[],
      features: [] as object[],
    };
  },
  watch: {
    projectId() {
      this.updateMenu();
    },
    projectName() {
      this.updateMenu();
    },
    projects() {
      this.updateMenu();
    },
    subprojects() {
      this.updateMenu();
    },
    resources() {
      this.updateMenu();
    },
    features() {
      this.updateMenu();
    },
    isOwner() {
      this.updateMenu();
    },
  },
  created() {
    this.projectId = GuidUtil.getProjectId();
    this.resourceId = GuidUtil.getResourceId();
    this.projects = [{title: this.$t('noProjects')}];
    if (GuidUtil.isValidGuid(this.projectId)) {
       ActivatedFeaturesApi.getActiveFeatures(this.projectId,
        (response: any) => {
          for (const feature of response.data) {
            this.features.push(feature);
          }
          this.createViewProject();
        },
      );
    } else {
      this.createViewDashboard();
    }
  },
  methods: {
    checkOwnership(projectRoles: any) {
      const thisComponent = this;
      for (const projectRole of projectRoles) {
        if (projectRole.role.displayName === 'Owner') {
          this.isOwner = true;
        }
      }
    },
    isFeatureActivated(featureNameEn: string = '') {
      for (const feature of this.features) {
        if ((feature as any).en === featureNameEn) {
          return true;
        }
      }
      return false;
    },
    checkActivatedClass(link: any, folder: boolean = false) {
      let url = window.location.href;
      if (url.indexOf('#') >= 0) {
        url = url.substring(0, url.indexOf('#'));
      }
      if (link === url) {
        return folder ? 'activatedFolder' : 'activated';
      }
      return '';
    },
    checkActivatedClassResourceFolder(link: any) {
      let url = window.location.href;
      if (url.indexOf('#') >= 0) {
        url = url.substring(0, url.indexOf('#'));
      }
      if (url.indexOf(link) >= 0) {
        return 'activatedFolder';
      }
      return '';
    },
    sortItemsByName(items: any) {
      items.sort((a: any, b: any) => (a.title > b.title ? 1 : b.title > a.title ? -1 : 0));
    },
    updateMenu() {
      const isProjectView = GuidUtil.isValidGuid(this.projectId);
      const menu = [
        {
          href: LinkUtil.getRootLink(),
          title: this.$t('home'),
          class: 'headerHome ' + this.checkActivatedClass(LinkUtil.getRootLink()),
        },
        {
          title: this.$t('projects'),
          child: this.projects,
          hidden: isProjectView || this.projects.length === 0,
        },
        {
          href: LinkUtil.getProjectLink(),
          title: this.$t('project') + this.projectName,
          class: this.checkActivatedClass(LinkUtil.getProjectLink()),
          hidden: !isProjectView,
        },
        {
          href: LinkUtil.getProjectLink('Lists/Announcement%20Board/AllItems'),
          title: this.$t('announcements'),
          class: this.checkActivatedClass(LinkUtil.getProjectLink('Lists/Announcement%20Board/AllItems')),
          hidden: !isProjectView || !this.isFeatureActivated('Announcement Board'),
        },
        {
          href: LinkUtil.getProjectLink('Lists/Discussion%20Board/AllItems'),
          title: this.$t('discussions'),
          class: this.checkActivatedClass(LinkUtil.getProjectLink('Lists/Discussion%20Board/AllItems')),
          hidden: !isProjectView || !this.isFeatureActivated('Discussion Board'),
        },
        {
          href: LinkUtil.getProjectLink('Shared%20Documents/Forms/AllItems'),
          title: this.$t('documents'),
          class: this.checkActivatedClass(LinkUtil.getProjectLink('Shared%20Documents/Forms/AllItems')),
          hidden: !isProjectView || !this.isFeatureActivated('Documents'),
        },
        {
          title: this.$t('resources'),
          child: this.resources,
          class: this.checkActivatedClassResourceFolder(LinkUtil.getProjectLink(
            'CreateResource', {resource_id: ''})) ||
            this.checkActivatedClassResourceFolder((LinkUtil.getProjectLink(
            'ViewResource', {resource_id: ''})) ),
          hidden: !isProjectView || this.resources.length === 0,
        },
        {
          title: this.$t('subprojects'),
          child: this.subprojects,
          hidden: !isProjectView || this.subprojects.length === 0,
        },
        {
          title: this.$t('settings'),
          hidden: !isProjectView || !this.isOwner,
          class: this.checkActivatedClass(LinkUtil.getProjectLink('UserManagement'), true) ||
            this.checkActivatedClass(LinkUtil.getProjectLink('EditProject'), true),
          child: [
            {
              href: LinkUtil.getProjectLink('EditProject'),
              title: this.$t('projectEdit'),
              class: this.checkActivatedClass(LinkUtil.getProjectLink('EditProject')),
              hidden: !isProjectView,
            },
            {
              href: LinkUtil.getProjectLink('UserManagement'),
              title: this.$t('userManagement'),
              class: this.checkActivatedClass(LinkUtil.getProjectLink('UserManagement')),
              hidden: !isProjectView,
            },
            {
              href: LinkUtil.getProjectLink('QuotaManagement'),
              title: this.$t('quotaManagement'),
              class: this.checkActivatedClass(LinkUtil.getProjectLink('QuotaManagement')),
              hidden: !isProjectView,
            },
          ],
        },
      ];
      this.$set(this, 'menu', menu);
    },
    createViewDashboard() {
      ProjectApi.getTopLevelProjectsWithoutAnalyticsLog((response: any) => {
        const projects = [] as object[];
        for (const project of response.data) {
          const name = project.displayName;
          projects.push({
            title: name,
            href: LinkUtil.getExternalProjectLink(project.slug),
          });
        }
        this.sortItemsByName(projects);
        this.$set(this, 'projects', projects);
      });
    },
    createViewProject() {
      ProjectRoleApi.getUserRoles(this.projectId, (responseA: any) => {
        this.checkOwnership(responseA.data);
      });

      ProjectApi.getProjectInformation(this.projectId, (responseB: any) => {
        this.$set(this, 'projectName', responseB.data.displayName);
      });
      SubProjectApi.getSubProjects(this.projectId, (responseC: any) => {
        const subprojects = [] as object[];
        for (const subproject of responseC.data) {
          const name = subproject.displayName;
          subprojects.push({
            title: name,
            href: LinkUtil.getExternalProjectLink(subproject.slug),
          });
        }
        this.sortItemsByName(subprojects);
        this.$set(this, 'subprojects', subprojects);
      });

      ProjectApi.getResourcesWithoutAnalyticsLog(this.projectId, (responseD: any) => {
        const resources = [] as object[];
        for (const resource of responseD.data) {
          const name = resource.type.displayName.toUpperCase() + ': ' + resource.displayName;   
          let content = {
            title: name,
            class: this.checkActivatedClass(
              LinkUtil.getProjectLink('ViewResource', {resource_id: resource.id}))
              || this.checkActivatedClass(
              LinkUtil.getProjectLink('CreateResource', {resource_id: resource.id})),
            href: LinkUtil.getProjectLink('ViewResource', {resource_id: resource.id}),
            badge: resource.archived ? { text: this.$t('archive.archived'), class: 'vsm--badge'} : undefined,
          };
          resources.push(content);
        }
        this.sortItemsByName(resources);
        this.$set(this, 'resources', resources);
      });
    },
  },
});
</script>

<style>
#sidebarmenu {
  width: inherit;
  overflow-y: auto;
  max-height: calc(100% - 50px);
}
#sidebarmenu .v-sidebar-menu {
  margin-left: 15px;
  margin-right: 15px;
  height: fit-content;
  max-height: inherit;
  position: absolute;
  top: 25px;
  left: auto;
  width: 220px;
  height: auto;
}
#sidebarmenu .vsm--arrow::after {
  content: '\25BA';
  font-size: large;
}
#sidebarmenu .vsm--list {
  height: fit-content;
  background-color: #fff;
}
#sidebarmenu .v-sidebar-menu > .vsm--list > .vsm--item {
  border-bottom: 1px dotted rgb(204, 204, 204);
  text-overflow: ellipsis;
}
#sidebarmenu .v-sidebar-menu > .vsm--list:first-child {
  border-top: 1px dotted rgb(204, 204, 204);
}
#sidebarmenu .vsm--link:hover {
  border-color: transparent;
}
#sidebarmenu .vsm--item .vsm--title {
  overflow: hidden;
  text-overflow: ellipsis;
}
#sidebarmenu .vsm--badge {
  display: inline-block;
  padding: .25em .4em;
  font-size: 75%;
  font-weight: 700;
  line-height: 1;
  text-align: center;
  white-space: nowrap;
  vertical-align: baseline;
  padding-right: .6em;
  padding-left: .6em;
  border-radius: 10rem;
  background-color: #ffc107;
}
#sidebarmenu .headerHome {
  font-weight: bold;
}
#sidebarmenu .activated,
#sidebarmenu .activatedFolder,
#sidebarmenu .vsm--link:hover,
#sidebarmenu .v-sidebar-menu.vsm_white-theme.vsm_expanded .vsm--item_open .vsm--link_level-1 {
  background-color: #00549f;
  color: #fff;
}
#sidebarmenu .vsm--item.vsm--item_open .activatedFolder,
#sidebarmenu .v-sidebar-menu.vsm_expanded .vsm--item_open .vsm--link_level-1{
  background-color: transparent !important;
  color: #000 !important
}
#sidebarmenu .vsm--item .vsm--list{
  padding: 0px;
}
menu#contentRow {
  margin-left: -250px;
  background-color: #e9ecef;
  -webkit-transition: all 0.3s linear;
  -moz-transition: all 0.3s linear;
  -o-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
.show-menu menu#contentRow {
  margin-left: 0px;
  visibility: visible;
  overflow: auto;
}
.app-content,
footer,
.skip-container {
  -webkit-transition: all 0.3s linear;
  -moz-transition: all 0.3s linear;
  -o-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
.show-menu .app-content,
.show-menu footer,
.show-menu .skip-container {
    margin-left: 250px;
}

@media (max-width: 767px) {
  .show-menu {
    overflow: hidden !important;
  }
  .show-menu #gray-layer {
    display: block !important;
  }
}

@media (min-width: 768px) {
  .show-menu-md menu {
    visibility: visible;
    margin-left: 0px;
    overflow: auto;
  }
  .show-menu-md .app-content,
  .show-menu-md footer,
  .show-menu-md .skip-container {
    margin-left: 250px;
  }
}
</style>
